# 4.3.0

Release date: `2019-11-14`

## Core

- [NXDRIVE-279](https://jira.nuxeo.com/browse/NXDRIVE-279): Refactor `LocalClient`
- [NXDRIVE-619](https://jira.nuxeo.com/browse/NXDRIVE-619): Keynote files should be synced
- [NXDRIVE-987](https://jira.nuxeo.com/browse/NXDRIVE-987): Unexpected full scans when synchronizing
- [NXDRIVE-1838](https://jira.nuxeo.com/browse/NXDRIVE-1838): Allow for one time synchronization of a file (Direct Transfer)
- [NXDRIVE-1851](https://jira.nuxeo.com/browse/NXDRIVE-1851): The config parser does not handle float values
- [NXDRIVE-1853](https://jira.nuxeo.com/browse/NXDRIVE-1853): Allow to Direct Transfer a folder and its contents
- [NXDRIVE-1855](https://jira.nuxeo.com/browse/NXDRIVE-1855): Add notifications for Direct Transfer actions
- [NXDRIVE-1856](https://jira.nuxeo.com/browse/NXDRIVE-1856): Prevent duplicate creation via Direct Transfer
- [NXDRIVE-1857](https://jira.nuxeo.com/browse/NXDRIVE-1857): Handle multi-account for Direct Transfers
- [NXDRIVE-1859](https://jira.nuxeo.com/browse/NXDRIVE-1859): [Windows] Fix the special file check for folder icon
- [NXDRIVE-1860](https://jira.nuxeo.com/browse/NXDRIVE-1860): Skip any `OSError` when trying to compress log files
- [NXDRIVE-1861](https://jira.nuxeo.com/browse/NXDRIVE-1861): [macOS] Fix `AttributeError`: 'SBApplication' object has no attribute 'documents'
- [NXDRIVE-1862](https://jira.nuxeo.com/browse/NXDRIVE-1862): Only upload files from the Direct Edit directory
- [NXDRIVE-1863](https://jira.nuxeo.com/browse/NXDRIVE-1863): Handle pair state modified-created as a conflict
- [NXDRIVE-1864](https://jira.nuxeo.com/browse/NXDRIVE-1864): Retry later when a `MaxRetryError` occures
- [NXDRIVE-1867](https://jira.nuxeo.com/browse/NXDRIVE-1867): Fix mypy issues following the update to mypy 0.730
- [NXDRIVE-1868](https://jira.nuxeo.com/browse/NXDRIVE-1868): [macOS] Use a custom trash implementation instead of using Send2Trash
- [NXDRIVE-1871](https://jira.nuxeo.com/browse/NXDRIVE-1871): Use the public Batch upload index
- [NXDRIVE-1872](https://jira.nuxeo.com/browse/NXDRIVE-1872): The Autolocker must respect the `ignored_prefixes` parameter
- [NXDRIVE-1875](https://jira.nuxeo.com/browse/NXDRIVE-1875): Use more processors by default (5 -> 10)
- [NXDRIVE-1876](https://jira.nuxeo.com/browse/NXDRIVE-1876): Fix threads not totally released
- [NXDRIVE-1879](https://jira.nuxeo.com/browse/NXDRIVE-1879): Drop the support for macOS 10.11 (**breaking change**)
- [NXDRIVE-1881](https://jira.nuxeo.com/browse/NXDRIVE-1881): Fix ineffective metrics preferences
- [NXDRIVE-1885](https://jira.nuxeo.com/browse/NXDRIVE-1885): Ignore files with the 'notInBinaryStore' digest
- [NXDRIVE-1886](https://jira.nuxeo.com/browse/NXDRIVE-1886): Direct Edit should be robust against connection errors
- [NXDRIVE-1890](https://jira.nuxeo.com/browse/NXDRIVE-1890): [Windows] Fix waiting during auto-upgrade
- [NXDRIVE-1892](https://jira.nuxeo.com/browse/NXDRIVE-1892): [macOS] Allow the app to be run from `$HOME/Applications`
- [NXDRIVE-1896](https://jira.nuxeo.com/browse/NXDRIVE-1896): Ensure to quit the application after an update in the console mode
- [NXDRIVE-1897](https://jira.nuxeo.com/browse/NXDRIVE-1897): The `clean-folder` CLI argument should ignore errors
- [NXDRIVE-1898](https://jira.nuxeo.com/browse/NXDRIVE-1898): Display a friendly message when the OS is not supported
- [NXDRIVE-1902](https://jira.nuxeo.com/browse/NXDRIVE-1902): Add the update channel in analytics report
- [NXDRIVE-1909](https://jira.nuxeo.com/browse/NXDRIVE-1909): [Context Menu] Remove the token from generated URLs
- [NXDRIVE-1915](https://jira.nuxeo.com/browse/NXDRIVE-1915): Fix local file creation when checking for an already synced file on the HDD
- [NXDRIVE-1919](https://jira.nuxeo.com/browse/NXDRIVE-1919): Remove staled transfers at startup

## GUI

- [NXDRIVE-1826](https://jira.nuxeo.com/browse/NXDRIVE-1826): Systray icon is blurry on macOS dark mode
- [NXDRIVE-1827](https://jira.nuxeo.com/browse/NXDRIVE-1827): [macOS] Dark mode not correctly handled
- [NXDRIVE-1839](https://jira.nuxeo.com/browse/NXDRIVE-1839): The GUI is not responsive when syncing a lot of files
- [NXDRIVE-1914](https://jira.nuxeo.com/browse/NXDRIVE-1914): Fix account name being hidden by icons in the systray menu

## Packaging / Build

- [NXDRIVE-1391](https://jira.nuxeo.com/browse/NXDRIVE-1391): [macOS] Upgrade PyQt from 5.11.2 to 5.13.1
- [NXDRIVE-1396](https://jira.nuxeo.com/browse/NXDRIVE-1396): [macOS] Upgrade PyObjC to 5.2
- [NXDRIVE-1710](https://jira.nuxeo.com/browse/NXDRIVE-1710): Check the auto-updater before building a new version
- [NXDRIVE-1820](https://jira.nuxeo.com/browse/NXDRIVE-1820): [Windows] Upgrade Inno Setup Indonesian translations
- [NXDRIVE-1884](https://jira.nuxeo.com/browse/NXDRIVE-1884): [Windows] Update the timestamping service URL

## Tests

- [NXDRIVE-947](https://jira.nuxeo.com/browse/NXDRIVE-947): Duplicates are created when the parent is renamed while syncing up
- [NXDRIVE-1854](https://jira.nuxeo.com/browse/NXDRIVE-1854): Add tests for the Direct Transfer feature
- [NXDRIVE-1882](https://jira.nuxeo.com/browse/NXDRIVE-1882): Add a recovery test: reusing an old synced folder
- [NXDRIVE-1904](https://jira.nuxeo.com/browse/NXDRIVE-1904): [Windows] Fix `test_get_default_local_folder()`
- [NXDRIVE-1905](https://jira.nuxeo.com/browse/NXDRIVE-1905): [Windows] Fix `test_normalize_and_expand_path()`

## Doc

- [NXDRIVE-](https://jira.nuxeo.com/browse/NXDRIVE-):

## Minor Changes

- Added `pyobjc-framework-CoreServices` 5.2
- Upgraded `certify` from 2019.6.16 to 2019.9.11
- Upgraded `nuxeo` from 2.2.2 to 2.2.4
- Upgraded `pypac` from 0.12.0 to 0.13.0
- Upgraded `pyqt5` from 5.13.0 to 5.13.1 on GNU/Linux and Windows
- Upgraded `pyqt5-sip` from 4.19.13 to 12.7.0 on macOS
- Upgraded `pyqt5-sip` from 4.19.18 to 12.7.0 on GNU/Linux and Windows
- Upgraded `pywin32` from 224 to 225
- Upgraded `sentry-sdk` from 0.11.2 to 0.12.3
- Upgraded `tld` from 0.9.3 to 0.9.6
- Upgraded `urllib3` from 1.25.3 to 1.25.6
- Removed `pyobjc-framework-LaunchServices`
- Removed `pyaml`
- Removed `send2trash` on macOS
- Removed `universal-analytics-python`

## Technical Changes

- Added `Application.ctx_upload_local_file()`
- Added `Application.force_refresh_files()`
- Added `Application.show_server_folders()`
- Removed `Application.ask_for_metrics_approval()`
- Added `CliHandler.ctx_direct_upload()`
- Added `Engine.directTranferDuplicateError()` signal
- Added `Engine.directTranferError()` signal
- Added `Engine.directTranferStatus()` signal
- Added `Engine.direct_transfer()`
- Added `Engine.direct_transfer_cancel()`
- Added `Engine.direct_transfer_replace_blob()`
- Added `Engine.remove_staled_transfers()`
- Added `EngineDAO.update_pair_state()`
- Changed `EngineDAO.get_download()` to return a generator instead of a list
- Changed `EngineDAO.get_upload()` to return a generator instead of a list
- Added `local_state` keyword argument to `EngineDAO.insert_local_state()`, defaults to `created` to not change the behavior.
- Renamed `FileModel.addFiles()` to `add_files()`
- Removed `FileModel.empty()`
- Removed `FileModel.insertRows()`
- Removed `FileModel.removeRows()`
- added `cleanup` keyword argument to `LocalClientMixin.clean_xattr_folder_recursive()`
- added `cleanup` keyword argument to `LocalClientMixin.remove_remote_id()`
- added `cleanup` keyword argument to `LocalClientMixin.remove_root_id()`
- Added `Manager.arch`
- Added `Manager.check_metrics_preferences()`
- Added `Manager.create_tracker()`
- Added `Manager.preferences_metrics_chosen`
- Added `Manager.tracker`
- Removed `Manager.get_tracking()`. Use `Options.analytics` instead.
- Added `check` keyword argument to `LocalClient.get_info()`, defaults to `True` to not change the behavior.
- Added `Remote.check_integrity_simple()`
- Added `Remote.direct_upload()`
- Added `Remote.get_document_or_none()`
- Added `interval` keyword argument to `Tracker.__init__()`
- Added `Tracker.send_directedit_edit()`
- Added `Tracker.send_directedit_open()`
- Added `Tracker.send_stats()`
- Removed `Tracker.fmt_event`
- Added client/local/base.py
- Added client/local/darwin.py
- Added client/local/linux.py
- Added client/local/windows.py
- Added exceptions.py::`DirectTransferDuplicateFoundError`
- Added gui/folders_dialog.py
- Added gui/folders_loader.py
- Added gui/folders_model.py
- Added notification.py::`DirectTransferError()`
- Added notification.py::`DirectTransferStatus()`
- Added utils.py::`ga_user_agent()`
- Added utils.py::`get_tree_size()`
- Added utils.py::`get_tree_list()`
- Added fatal_error.py::`check_os_version()`
- Changed `LocalClient.has_folder_icon()` to return only a boolean
- Removed `url` argument from `DirectEdit.__init__()`
- Removed `DirectEdit.handle_url()`
- Removed `DirectEdit.url`
- Removed `FiltersDialog`. Use `DocumentsDialog` instead.
- Removed `FolderTreeview`. Use `DocumentTreeView` instead.
- Removed client/local_client.py
